---
title: Enable the Autocomplete Function
product: Form Library
description: Autocomplete is a feature that predicts the rest of a word while the user is typing. Enable it to allow respondents to easily find and choose from pre-populated answer choices. A free demo example for JavaScript.
framework: jQuery
source: https://surveyjs.io/form-library/examples/enable-autocomplete-survey-form/jquery
index: https://surveyjs.io/form-library/examples/overview.md
---

# Enable the Autocomplete Function (jQuery)

Autocomplete is a word completion feature that displays predictive text based on the entered characters and allows respondents to fill a survey field after they enter only a few characters. This example demonstrates and describes how to add this feature to your survey. Start typing into the input field to see autocomplete suggestions.

The autocomplete functionality is built upon a third-party [EasyAutocomplete](http://easyautocomplete.com/) jQuery plugin. Reference the plugin's script and style sheet on your page. You should also reference a script that integrates the SurveyJS Form Library with third-party libraries (`surveyjs-widgets.js`). Open the HTML tab and copy the links from there.

To create a survey question with enabled autocomplete, configure a regular [Text](https://surveyjs.io/form-library/documentation/questiontextmodel) question and then specify a `choices` array for it. Populate the array with autocomplete suggestions. This configuration activates the autocomplete functionality automatically.

## Files

### `public/index.html`

```html
<link href="https://fonts.googleapis.com/css?family=Open%20Sans:400,600&display=swap" rel="stylesheet">
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import $ from "jquery";
import { Model } from "survey-core";
import "survey-js-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

import * as SurveyCore from "survey-core";
import { autocomplete } from "surveyjs-widgets";

window["$"] = window["jQuery"] = $;
require("easy-autocomplete/dist/jquery.easy-autocomplete.js");
autocomplete(SurveyCore);
const survey = new Model(json);
survey.onComplete.add((sender, options) => {
    console.log(JSON.stringify(sender.data, null, 3));
});

$("#surveyElement").Survey({ model: survey });
```

### `src/json.js`

```js
export const json = {
  "elements": [
    {
      "name": "car-brand",
      "title": "What is the brand of your car?",
      "description": "Start typing to see autocomplete predictions.",
      "type": "text",
      "choices": [ "Ford", "Vauxhall", "Volkswagen", "Nissan", "Audi", "Mercedes-Benz", "BMW", "Peugeot", "Toyota", "Citroen" ]
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "jquery": "latest",
    "jquery": "latest",
    "easy-autocomplete": "1.3.5",
    "surveyjs-widgets": "latest",
    "survey-core": "latest",
    "survey-js-ui": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/enable-autocomplete-survey-form/angular.md)
- [React](https://surveyjs.io/form-library/examples/enable-autocomplete-survey-form/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/enable-autocomplete-survey-form/vue3js.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/enable-autocomplete-survey-form/vanillajs.md)


---
title: Enable the Autocomplete Function
product: Form Library
description: Autocomplete is a feature that predicts the rest of a word while the user is typing. Enable it to allow respondents to easily find and choose from pre-populated answer choices. A free demo example for JavaScript.
framework: React
source: https://surveyjs.io/form-library/examples/enable-autocomplete-survey-form/reactjs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Enable the Autocomplete Function (React)

Autocomplete is a word completion feature that displays predictive text based on the entered characters and allows respondents to fill a survey field after they enter only a few characters. This example demonstrates and describes how to add this feature to your survey. Start typing into the input field to see autocomplete suggestions.

The autocomplete functionality is built upon a third-party [EasyAutocomplete](http://easyautocomplete.com/) jQuery plugin. Reference the plugin's script and style sheet on your page. You should also reference a script that integrates the SurveyJS Form Library with third-party libraries (`surveyjs-widgets.js`). Open the HTML tab and copy the links from there.

To create a survey question with enabled autocomplete, configure a regular [Text](https://surveyjs.io/form-library/documentation/questiontextmodel) question and then specify a `choices` array for it. Populate the array with autocomplete suggestions. This configuration activates the autocomplete functionality automatically.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/SurveyComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";
import $ from "jquery";
import * as SurveyCore from "survey-core";
import { autocomplete } from "surveyjs-widgets";

window["$"] = window["jQuery"] = $;
require("easy-autocomplete/dist/jquery.easy-autocomplete.js");
autocomplete(SurveyCore);
function SurveyComponent() {
    const survey = new Model(json);
    survey.onComplete.add((sender, options) => {
        console.log(JSON.stringify(sender.data, null, 3));
    });
    return (<Survey model={survey} />);
}

export default SurveyComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyComponent from "./SurveyComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyComponent />);
```

### `src/json.js`

```js
export const json = {
  "elements": [
    {
      "name": "car-brand",
      "title": "What is the brand of your car?",
      "description": "Start typing to see autocomplete predictions.",
      "type": "text",
      "choices": [ "Ford", "Vauxhall", "Volkswagen", "Nissan", "Audi", "Mercedes-Benz", "BMW", "Peugeot", "Toyota", "Citroen" ]
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "jquery": "latest",
    "easy-autocomplete": "1.3.5",
    "surveyjs-widgets": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/enable-autocomplete-survey-form/angular.md)
- [Vue 3](https://surveyjs.io/form-library/examples/enable-autocomplete-survey-form/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/enable-autocomplete-survey-form/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/enable-autocomplete-survey-form/vanillajs.md)
